LeetCode198:House Robber

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.

Example 2:

Input: [2,7,9,3,1]
Output: 12
Explanation: Rob house 1 (money = 2), rob house 3 (money = 9) and rob house 5 (money = 1).
             Total amount you can rob = 2 + 9 + 1 = 12.

LeetCode:链接

题意:你是一个专业的强盗,你计划在一条路上抢劫房屋。每一个房屋藏着一些钱。因为相邻房屋之间有安全系统相连,这个安全系统又与警察相连,所以你不能抢劫相邻的房屋在同一个晚上。 给你一列非负整数代表每一个房屋的藏的钱数,求出在没有惊扰警察的情况下,能抢劫到的最多的钱数。

题解:不能取相邻元素,动态规划的思想是将大问题转换为逐个的小问题。 

假设: 1. 只有1个房屋nums[0],最大收益为dp[0] = nums[0]; 
2. 有2个房屋nums[0], nums[1], 不能同时取,最大收益为dp[1] = max(nums[0], nums[1]); 
3. 有3个房屋,有两种取法,取nums[1],或者取nums[0]和nums[2].即 dp[2] = max(nums[1], nums[0] + nums[2]); 
4. 故可推测出动态转换方程为:dp[i] = max(nums[i] + dp[i-2], dp[i-1])

class Solution(object):
    def rob(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        if len(nums) == 0:
            return 0
        if len(nums) <= 2:
            return max(nums)
        dp = [0] * len(nums)
        dp[0] = nums[0]
        dp[1] = max(nums[0], nums[1])
        for i in range(2, len(nums)):
            dp[i] = max(nums[i] + dp[i-2], dp[i-1])
        return dp[-1]

猜你喜欢

转载自blog.csdn.net/mengmengdajuanjuan/article/details/84946844
今日推荐